module CYCSRS.Processors.Encoders.Tools(fresh,freshI,fst5) where

import CYCSRS.Types
import Data.List


  
      
-- 
-- generate Fresh symbols by prepending an 'A'      
fresh :: Alphabet -> Alphabet -> [(Symbol,Symbol)]
fresh alph symbols = go (zip symbols symbols) []
 where
   go :: [(Symbol,Symbol)] -> [(Symbol,Symbol)] -> [(Symbol,Symbol)] 
   go [] ret = ret
   go ((o,s):xs) ret
    | s `elem` alph = go ((o,('A':s)):xs) ret
    | s `elem` (map snd ret) = go ((o,('A':s)):xs) ret
    | otherwise = go xs ((o,s):ret)
    
    
-- generate Fresh symbols by prepending a user defined symbol
freshI :: Char -> Alphabet -> Alphabet -> [(Symbol,Symbol)]
freshI i alph symbols = go (zip symbols symbols) []
 where
   go :: [(Symbol,Symbol)] -> [(Symbol,Symbol)] -> [(Symbol,Symbol)] 
   go [] ret = ret
   go ((o,s):xs) ret
    | s `elem` alph = go ((o,(i:s)):xs) ret
    | s `elem` (map snd ret) = go ((o,(i:s)):xs) ret
    | otherwise = go xs ((o,s):ret)    
    
fst5 (a,_,_,_,_) = a    